import Flutter
import UIKit

public class SwiftHttpPrismaPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
      let channel = FlutterMethodChannel(name: "http_prisma", binaryMessenger: registrar.messenger())
      let instance = SwiftHttpPrismaPlugin()
      registrar.addMethodCallDelegate(instance, channel: channel)
    }

    public func convertToDictionary(text: String) -> [String: Any]? {
        if let data = text.data(using: .utf8) {
            do {
                return try JSONSerialization.jsonObject(with: data, options: []) as? [String: Any]
            } catch {
                print(error.localizedDescription)
            }
        }
        return nil
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {

        if(call.method.elementsEqual("postDecidir"))
        {
            let arguments = call.arguments as? NSDictionary
            let destreq = arguments!["url"] as? String
            let apikey = arguments!["apikey"] as? String

            let payload = arguments!["payload"] as? String
            let dict = convertToDictionary(text: payload ?? "{}")

            let url = URL(string: destreq ?? "https://live.decidir.com/api/v2/tokens")!
            var request = URLRequest(url: url)
            request.httpMethod = "POST"
            request.setValue("application/json", forHTTPHeaderField: "Content-Type")
            request.addValue("application/json", forHTTPHeaderField: "Accept")
            request.addValue(apikey ?? "e9cdb99fff374b5f91da4480c8dca741", forHTTPHeaderField: "apikey")

            let bodyData = try? JSONSerialization.data(
                withJSONObject: dict,
                options: []
            )

            request.httpBody = bodyData

            NSURLConnection.sendAsynchronousRequest(request, queue: OperationQueue.main) {(response, data, error) in
                guard let data = data else { return }
                result(String(data: data, encoding: .utf8)!)
            }
        }else{
            result("iOS " + UIDevice.current.systemVersion)
        }
    }
}
