import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:http_prisma/http_prisma.dart';

void main() {
  const MethodChannel channel = MethodChannel('http_prisma');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await HttpPrisma.platformVersion, '42');
  });
}
